module ActionView
  module Component
    module Live
      class LiveUpdater
        class << self
          def update(model)
            model_name = model.class.name
            return unless subscriptions[model_name].present?

            subscriptions[model_name].each do |component_name|
              locals = {model_name.underscore.to_sym => model}
              body = ApplicationController.render template: 'live', layout: false, locals: {component: component_name, locals: locals}
              LiveChannel.broadcast_to "#{component_name}:#{model.id}", body: body
            end
          end

          def subscribe(model, component_name)
            subscriptions[model] ||= []
            subscriptions[model] << component_name
          end

          def subscriptions
            @subscriptions ||= {}
          end
        end
      end
    end
  end
end
