module ActionView
  module Component
    module Live
      module Subscriber
        extend ActiveSupport::Concern

        def live_render!
          @live_render = true
        end

        def live_render?
          @live_render
        end

        class_methods do
          def listen_to(name)
            LiveUpdater.subscribe(name.to_s.classify, self)
          end
        end

        # Used as view helper to wrap view in div that will connect to auto-updating stimulus controller
        # If we render the component in live update on cable we will not wrap it - we just need the component content.
        #
        def live
          return yield if live_render?
          # <div data-controller="live" data-live-component="UserCardComponent" data-live-id="<%= id %>">
          content_tag(:div, nil, data: {controller: :live, live_component: self.class.name, live_id: id}) { yield }
        end
      end
    end
  end
end
